package gui;

import java.awt.*;
import java.util.List;

import javax.swing.*;

import util.*;

public class GuiImageLabel implements Drawable {

	protected int x;
	protected int y;

	protected String imageURL;
	protected Image image;
	protected int width, height;

	public GuiImageLabel(int x, int y, String imageURL) {
		this.x = x;
		this.y = y;

		this.imageURL = imageURL;
		try {
			if (imageURL != null) {
				ImageIcon icon = new ImageIcon(imageURL);
				image = icon.getImage();
				width = image.getWidth(null);
				height = image.getHeight(null);
			}
		} catch (Exception e) {
			Log.log(e, "Immage " + imageURL);
		}

	}

	public void draw(Graphics g) {
		if (image != null) {
			Graphics2D g2 = (Graphics2D) g;
			g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
			g.drawImage(image, x, y, width, height, null);

		}
	}

	public void update() {
	}

	@Override
	public int getWidth() {
		return width;
	}

	@Override
	public int getHeight() {
		return height;
	}

	@Override
	public Point getCorner(int corner) {
		switch (corner) {
		case TOPLEFT:
			return new Point(x, y - getHeight());
		case TOPRIGHT:
			return new Point(x + getWidth(), y - getHeight());
		case BOTOMLEFT:
			return new Point(x, y);
		case BOTOMRIGHT:
			return new Point(x + getWidth(), y);
		}
		return null;
	}

	@Override
	public List<Drawable> getDrawables() {
		// TODO Auto-generated method stub
		return null;
	}
}
