package gui;

import java.awt.*;

import util.DrawUtils;
import logic.Pin;

// Klasa koja predstavja jednu labelu
// labela ima jedan ulazni pin
public class GuiPinLabel extends GuiTextLabel {

	protected Pin pin;

	public GuiPinLabel(int x, int y, Pin pin) {
		super(x, y, "", DrawUtils.ALIGNRIGHT, 12, "Arial", Font.BOLD, Color.BLACK, 0);
		this.pin = pin;
	}

	public void draw(Graphics g) {
		update();

		if (!pin.isHighZ()) {
			super.draw(g);
		}
	}

	public void update() {
		if (!pin.isHighZ()) {
			switch (pin.getNumOfLines()) {
			case 4:
				label = String.format("%01x", pin.getIntVal()).toUpperCase();
				break;
			case 8:
				label = String.format("%02x", pin.getIntVal()).toUpperCase();
				break;
			case 12:
				label = String.format("%03x", pin.getIntVal()).toUpperCase();
				break;
			case 16:
				label = String.format("%04x", pin.getIntVal()).toUpperCase();
				break;
			case 24:
				label = String.format("%06x", pin.getIntVal()).toUpperCase();
				break;
			case 32:
				label = String.format("%08x", pin.getIntVal()).toUpperCase();
				break;
			default:
				label = Integer.toHexString(pin.getIntVal());
				break;
			}

		}
	}

	public Pin getPin() {
		return pin;
	}

	public void setPin(Pin pin) {
		this.pin = pin;
	}
}
