package logic.components;

import util.Log;
import logic.*;

public class IntToBools extends LogicalComponent {

	public IntToBools(int out) {
		super(1, out);

	}

	public IntToBools(int out, String name) {
		super(1, out);
		this.name = name;
	}

	public void func() {
		int mval = in[0].getIntVal();

		for (int j = 0; j < out.length; j++) {
			boolean bVal = (mval & 1) == 1;
			mval = mval >> 1;
			if (in[0].isHighZ()) {
				out[j].setHighZ(true);
			} else {
				out[j].setHighZ(false);
				out[j].setBoolVal(bVal);
			}
		}

	}

	@Override
	public void initArgs(String[] args) {
		try {
			this.args = args;
			this.name = args[1];
			for (int i = 0; i < out.length; i++) {
				Pin pin = out[i];
				String outName = args[4 + i];
				pin.setName(outName);
			}
		} catch (Exception e) {
			Log.log("Wrong number of arguments on Split " + this.name
					+ ". Expected " + (4 + out.length));
		}
	}

}
