package util;

import java.awt.*;
import java.awt.font.*;
import java.awt.geom.*;

public class DrawUtils {
	public static final int ALIGNRIGHT = 0;
	public static final int ALIGNLEFT = 1;
	public static final int ALIGCENTER = 2;

	public static int moveString(int x, String text, int fontSize, String fontName, int fontStyle) {

		int result = x - stringWidth(text, fontSize, fontName, fontStyle);

		return result;
	}

	public static int calcX(int x, String label, int alignment, int fontSize, String fontName, int fontStyle) {
		switch (alignment) {
		case ALIGNRIGHT:
			return x;
		case ALIGNLEFT:
			return DrawUtils.moveString(x, label, fontSize, fontName, fontStyle);
		case ALIGCENTER:
			return (DrawUtils.moveString(x, label, fontSize, fontName, fontStyle) + x) / 2;
		default:
			return x;
		}
	}

	public static int stringWidth(String text, int fontSize, String fontName, int fontStyle) {

		Font f = new Font(fontName, fontStyle, fontSize);
		Rectangle2D r = f.getStringBounds(text, new FontRenderContext(null, RenderingHints.VALUE_TEXT_ANTIALIAS_DEFAULT,
				RenderingHints.VALUE_FRACTIONALMETRICS_DEFAULT));

		int result = (int) (r.getWidth());

		return result;
	}
	
	public static int stringHeight(String text, int fontSize, String fontName, int fontStyle) {

		Font f = new Font(fontName, fontStyle, fontSize);
		Rectangle2D r = f.getStringBounds(text, new FontRenderContext(null, RenderingHints.VALUE_TEXT_ANTIALIAS_DEFAULT,
				RenderingHints.VALUE_FRACTIONALMETRICS_DEFAULT));

		int result = (int) (r.getHeight());

		return result;
	}
}
